#appendto BOOM

func Launch(int angle, object clonk)
{
	if(clonk) clonk->AddEffect("RespawnBoom",clonk,1,90,nil,nil);
	return _inherited(angle, clonk);
}

func ControlRight()
{	
	SetRDir(+9);
	return true;
}

func ControlLeft()
{
	SetRDir(-9);
	return true;
}

func ControlUp()
{
  var angle = GetR()+RandomX(-24,24);
  SetXDir(3*GetXDir()/4+Sin(angle,64));
  SetYDir(3*GetYDir()/4-Cos(angle,64));
  SetR(angle);
}

func DoFireworks(int speed)
{
	RemoveEffect("Flight",this);
	
	var color = HSL(Random(8)*32,255,127);
	
	if(!speed) speed = 12;
	for(var i=0; i<36; ++i)
	{
		var oangle = Random(70);
		var num = AddEffect("Firework", nil, 300, 1, nil, GetID(), Cos(oangle,speed), i*10+Random(5), GetX(), GetY());
		EffectVar(4,nil,num) = color;
	}
	
	for(var i=0; i<16; ++i)
	{
		CreateParticle("ExploSmoke",RandomX(-80,80),RandomX(-80,80),0,0,RandomX(500,700),RGBa(255,255,255,90));
	}
	CastParticles("Spark",60,190,0,0,40,70,color,color);
	
	CreateParticle("FireworkGlow",0,0,0,0,3500,color | (200 & 255)<<24);
	
	Explode(55);
}
